#  Makefile.inc
#  LuaConsole
#  2016.7.16. Toshi Nagata
#  Copyright 2016 Toshi Nagata. All rights reserved.
#
#  This file is to be included from SOME_DIR/Makefile
#  It assumes that the current directory is SOME_DIR

SUBDIR := $(shell basename $(PWD))

LUA_SRCS := lapi.c lauxlib.c lbaselib.c lbitlib.c lcode.c lcorolib.c lctype.c ldblib.c ldebug.c ldo.c ldump.c lfunc.c lgc.c linit.c liolib.c llex.c lmathlib.c lmem.c loadlib.c lobject.c lopcodes.c loslib.c lparser.c lstate.c lstring.c lstrlib.c ltable.c ltablib.c ltm.c lundump.c lutf8lib.c lvm.c lzio.c

COMMON_SRCS := edit.c graph.c luacon.c screen.c

SRCS := $(patsubst %.c,../lua_src/%.c,$(LUA_SRCS)) \
 $(patsubst %.c,../src/%.c,$(COMMON_SRCS)) \
 $(patsubst %.c,../$(SUBDIR)/%.c,$(SPEC_SRCS))

CC ?= gcc
TARGET ?= luacon

OBJS := $(patsubst ../%.c,build/%.o,$(SRCS)) 
DEPS := $(patsubst ../%.c,build/%.d,$(SRCS))

INCLUDES += -I. -I../src -I../lua_src
CFLAGS ?= -O2 -g

CFLAGS += $(ARCHFLAGS) $(BASEFLAGS) $(INCLUDES) -DLUA_C89_NUMBERS
LDFLAGS += $(ARCHFLAGS)
LIBS += -lm

all: subdir luacon/$(TARGET)

-include $(DEPS)

subdir:
	mkdir -p build/$(SUBDIR) build/lua_src build/src luacon

luacon/$(TARGET): $(OBJS)
	rm -f luacon/*
ifeq ($(BAREMETAL),)
	$(CC) -o $@ $(OBJS) $(SYS_OBJS) $(LDFLAGS) $(LIBS)
else
	$(CXX) $(LDFLAGS) -Wl,-Map=build/kernel.map -o build/kernel.elf $(OBJS) $(LIBS)
	$(OBJCOPY) build/kernel.elf -O binary $@
endif
	cp -f ../fontdata.bin ../*.lua luacon

clean:
	rm -rf build luacon

y.tab.c y.tab.h: grammar.y
	bison -d -y $<

build/%.o: ../%.c Makefile
	$(CC) $(CFLAGS) -MMD -c $< -o $@
